/[gentoo-x86]/eclass/mysql.eclass
Gentoo

Diff of /eclass/mysql.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.73 Revision 1.117
1# Copyright 1999-2007 Gentoo Foundation 1# Copyright 1999-2007 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/mysql.eclass,v 1.73 2007/04/15 13:00:51 robbat2 Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/mysql.eclass,v 1.117 2009/11/19 18:22:44 robbat2 Exp $
4 4
5# Author: Francesco Riosa (Retired) <vivo@gentoo.org> 5# Author: Francesco Riosa (Retired) <vivo@gentoo.org>
6# Maintainer: MySQL Team <mysql-bugs@gentoo.org>
6# Maintainer: Luca Longinotti <chtekk@gentoo.org> 7# - Luca Longinotti <chtekk@gentoo.org>
7 8# - Robin H. Johnson <robbat2@gentoo.org>
8# Both MYSQL_VERSION_ID and MYSQL_PATCHSET_REV must be set in the ebuild too!
9# Note that MYSQL_VERSION_ID must be empty!
10 9
11WANT_AUTOCONF="latest" 10WANT_AUTOCONF="latest"
12WANT_AUTOMAKE="latest" 11WANT_AUTOMAKE="latest"
13 12
14inherit eutils flag-o-matic gnuconfig autotools mysql_fx 13inherit eutils flag-o-matic gnuconfig autotools mysql_fx versionator
14
15case "${EAPI:-0}" in
16 2)
17 EXPORT_FUNCTIONS pkg_setup \
18 src_unpack src_prepare \
19 src_configure src_compile \
20 src_install \
21 pkg_preinst pkg_postinst \
22 pkg_config pkg_postrm
23 IUSE_DEFAULT_ON='+'
24 ;;
25 *)
26 EXPORT_FUNCTIONS pkg_setup \
27 src_unpack \
28 src_compile \
29 src_install \
30 pkg_preinst pkg_postinst \
31 pkg_config pkg_postrm
32 ;;
33esac
15 34
16# Shorten the path because the socket path length must be shorter than 107 chars 35# Shorten the path because the socket path length must be shorter than 107 chars
17# and we will run a mysql server during test phase 36# and we will run a mysql server during test phase
18S="${WORKDIR}/mysql" 37S="${WORKDIR}/mysql"
19 38
20[[ "${MY_EXTRAS_VER}" == "latest" ]] && MY_EXTRAS_VER="20070108" 39[[ "${MY_EXTRAS_VER}" == "latest" ]] && MY_EXTRAS_VER="20090228-0714Z"
21 40if [[ "${MY_EXTRAS_VER}" == "live" ]]; then
22if [[ ${PR#r} -lt 60 ]] ; then 41 EGIT_PROJECT=mysql-extras
23 IS_BITKEEPER=0 42 EGIT_REPO_URI="git://git.overlays.gentoo.org/proj/mysql-extras.git"
24elif [[ ${PR#r} -lt 90 ]] ; then 43 inherit git
25 IS_BITKEEPER=60
26else
27 IS_BITKEEPER=90
28fi 44fi
29 45
30# MYSQL_VERSION_ID will be: 46# MYSQL_VERSION_ID will be:
31# major * 10e6 + minor * 10e4 + micro * 10e2 + gentoo revision number, all [0..99] 47# major * 10e6 + minor * 10e4 + micro * 10e2 + gentoo revision number, all [0..99]
32# This is an important part, because many of the choices the MySQL ebuild will do 48# This is an important part, because many of the choices the MySQL ebuild will do
33# depend on this variable. 49# depend on this variable.
34# In particular, the code below transforms a $PVR like "5.0.18-r3" in "5001803" 50# In particular, the code below transforms a $PVR like "5.0.18-r3" in "5001803"
51# We also strip off upstream's trailing letter that they use to respin tarballs
35 52
36MYSQL_VERSION_ID="" 53MYSQL_VERSION_ID=""
54tpv="${PV%[a-z]}"
37tpv=( ${PV//[-._]/ } ) ; tpv[3]="${PVR:${#PV}}" ; tpv[3]="${tpv[3]##*-r}" 55tpv=( ${tpv//[-._]/ } ) ; tpv[3]="${PVR:${#PV}}" ; tpv[3]="${tpv[3]##*-r}"
38for vatom in 0 1 2 3 ; do 56for vatom in 0 1 2 3 ; do
39 # pad to length 2 57 # pad to length 2
40 tpv[${vatom}]="00${tpv[${vatom}]}" 58 tpv[${vatom}]="00${tpv[${vatom}]}"
41 MYSQL_VERSION_ID="${MYSQL_VERSION_ID}${tpv[${vatom}]:0-2}" 59 MYSQL_VERSION_ID="${MYSQL_VERSION_ID}${tpv[${vatom}]:0-2}"
42done 60done
43# strip leading "0" (otherwise it's considered an octal number by BASH) 61# strip leading "0" (otherwise it's considered an octal number by BASH)
44MYSQL_VERSION_ID=${MYSQL_VERSION_ID##"0"} 62MYSQL_VERSION_ID=${MYSQL_VERSION_ID##"0"}
45 63
64# Community features are available in mysql-community
65# AND in the re-merged mysql-5.0.82 and newer
66if [ "${PN}" == "mysql-community" ]; then
67 MYSQL_COMMUNITY_FEATURES=1
68elif [ "${PV#5.0}" != "${PV}" ] && mysql_version_is_at_least "5.0.82"; then
69 MYSQL_COMMUNITY_FEATURES=1
70elif [ "${PV#5.1}" != "${PV}" ] && mysql_version_is_at_least "5.1.28"; then
71 MYSQL_COMMUNITY_FEATURES=1
72else
73 MYSQL_COMMUNITY_FEATURES=0
74fi
75
46# Be warned, *DEPEND are version-dependant 76# Be warned, *DEPEND are version-dependant
77# These are used for both runtime and compiletime
47DEPEND="ssl? ( >=dev-libs/openssl-0.9.6d ) 78DEPEND="ssl? ( >=dev-libs/openssl-0.9.6d )
48 userland_GNU? ( sys-process/procps ) 79 userland_GNU? ( sys-process/procps )
49 >=sys-apps/sed-4 80 >=sys-apps/sed-4
50 >=sys-apps/texinfo-4.7-r1 81 >=sys-apps/texinfo-4.7-r1
51 >=sys-libs/readline-4.1 82 >=sys-libs/readline-4.1
55for i in "" "-community" ; do 86for i in "" "-community" ; do
56 [[ "${i}" == ${PN#mysql} ]] || 87 [[ "${i}" == ${PN#mysql} ]] ||
57 DEPEND="${DEPEND} !dev-db/mysql${i}" 88 DEPEND="${DEPEND} !dev-db/mysql${i}"
58done 89done
59 90
91RDEPEND="${DEPEND}
92 !minimal? ( dev-db/mysql-init-scripts )
93 selinux? ( sec-policy/selinux-mysql )"
94
95# compile-time-only
60mysql_version_is_at_least "5.1" \ 96mysql_version_is_at_least "5.1" \
61|| DEPEND="${DEPEND} berkdb? ( sys-apps/ed )" 97|| DEPEND="${DEPEND} berkdb? ( sys-apps/ed )"
62 98
99# compile-time-only
63mysql_version_is_at_least "5.1.12" \ 100mysql_version_is_at_least "5.1.12" \
64&& DEPEND="${DEPEND} innodb? ( >=dev-util/cmake-2.4.3 )" 101&& DEPEND="${DEPEND} >=dev-util/cmake-2.4.3"
65 102
66# dev-perl/DBD-mysql is needed by some scripts installed by MySQL 103# dev-perl/DBD-mysql is needed by some scripts installed by MySQL
67PDEPEND="perl? ( >=dev-perl/DBD-mysql-2.9004 )" 104PDEPEND="perl? ( >=dev-perl/DBD-mysql-2.9004 )"
68 105
69# BitKeeper dependency, compile-time only 106# For other stuff to bring us in
70[[ ${IS_BITKEEPER} -eq 90 ]] && DEPEND="${DEPEND} dev-util/bk_client" 107PDEPEND="${PDEPEND} =virtual/mysql-$(get_version_component_range 1-2 ${PV})"
108
109# Work out the default SERVER_URI correctly
110if [ -z "${SERVER_URI}" ]; then
111 # The community build is on the mirrors
112 if [ "${MYSQL_COMMUNITY_FEATURES}" == "1" ]; then
113 SERVER_URI="mirror://mysql/Downloads/MySQL-${PV%.*}/mysql-${PV//_/-}.tar.gz"
114 # The (old) enterprise source is on the primary site only
115 elif [ "${PN}" == "mysql" ]; then
116 SERVER_URI="ftp://ftp.mysql.com/pub/mysql/src/mysql-${PV//_/-}.tar.gz"
117 fi
118fi
71 119
72# Define correct SRC_URIs 120# Define correct SRC_URIs
73SRC_URI="${SERVER_URI} 121SRC_URI="${SERVER_URI}"
122
123[[ ${MY_EXTRAS_VER} != live ]] && SRC_URI="${SRC_URI}
74 mirror://gentoo/mysql-extras-${MY_EXTRAS_VER}.tar.bz2 124 mirror://gentoo/mysql-extras-${MY_EXTRAS_VER}.tar.bz2
75 http://g3nt8.org/patches/mysql-extras-${MY_EXTRAS_VER}.tar.bz2" 125 http://g3nt8.org/patches/mysql-extras-${MY_EXTRAS_VER}.tar.bz2"
76mysql_version_is_at_least "5.1.12" \ 126mysql_version_is_at_least "5.1.12" \
77&& [[ -n "${PBXT_VERSION}" ]] \ 127&& [[ -n "${PBXT_VERSION}" ]] \
78&& SRC_URI="${SRC_URI} pbxt? ( mirror://sourceforge/pbxt/pbxt-${PBXT_VERSION}.tar.gz )" 128&& SRC_URI="${SRC_URI} pbxt? ( mirror://sourceforge/pbxt/pbxt-${PBXT_VERSION}.tar.gz )"
79 129
80DESCRIPTION="A fast, multi-threaded, multi-user SQL database server." 130DESCRIPTION="A fast, multi-threaded, multi-user SQL database server."
81HOMEPAGE="http://www.mysql.com/" 131HOMEPAGE="http://www.mysql.com/"
82LICENSE="GPL-2" 132LICENSE="GPL-2"
83SLOT="0" 133SLOT="0"
84IUSE="big-tables debug embedded minimal perl selinux ssl static" 134IUSE="big-tables debug embedded minimal ${IUSE_DEFAULT_ON}perl selinux ssl static"
85RESTRICT="confcache"
86 135
87mysql_version_is_at_least "4.1" \ 136mysql_version_is_at_least "4.1" \
88&& IUSE="${IUSE} latin1" 137&& IUSE="${IUSE} latin1"
89 138
90mysql_version_is_at_least "4.1.3" \ 139mysql_version_is_at_least "4.1.3" \
95 144
96mysql_version_is_at_least "5.0.18" \ 145mysql_version_is_at_least "5.0.18" \
97&& IUSE="${IUSE} max-idx-128" 146&& IUSE="${IUSE} max-idx-128"
98 147
99mysql_version_is_at_least "5.1" \ 148mysql_version_is_at_least "5.1" \
100&& IUSE="${IUSE} innodb"
101
102mysql_version_is_at_least "5.1" \
103|| IUSE="${IUSE} berkdb" 149|| IUSE="${IUSE} berkdb"
104 150
105mysql_version_is_at_least "5.1.12" \ 151mysql_version_is_at_least "5.1.12" \
106&& IUSE="${IUSE} pbxt" 152&& IUSE="${IUSE} pbxt"
107 153
108RDEPEND="${DEPEND} 154[ "${MYSQL_COMMUNITY_FEATURES}" == "1" ] \
109 !minimal? ( dev-db/mysql-init-scripts ) 155&& IUSE="${IUSE} ${IUSE_DEFAULT_ON}community profiling"
110 selinux? ( sec-policy/selinux-mysql )"
111
112EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_preinst \
113 pkg_postinst pkg_config pkg_postrm
114 156
115# 157#
116# HELPER FUNCTIONS: 158# HELPER FUNCTIONS:
117# 159#
118
119bitkeeper_fetch() {
120 local reposuf
121 if [[ -z "${1}" ]] ; then
122 local tpv
123 tpv=( ${PV//[-._]/ } )
124 reposuf="mysql-${tpv[0]}.${tpv[1]}"
125 else
126 reposuf="${1}"
127 fi
128 einfo "Using '${reposuf}' repository."
129 local repo_uri="bk://mysql.bkbits.net/${reposuf}"
130 ## -- ebk_store_dir: bitkeeper sources store directory
131 local ebk_store_dir="${PORTAGE_ACTUAL_DISTDIR-${DISTDIR}}/bk-src"
132 ## -- ebk_fetch_cmd: bitkeeper fetch command
133 # always fetch the latest revision, use -r<revision> if a specified revision is wanted
134 # hint: does not work
135 local ebk_fetch_cmd="sfioball"
136 ## -- ebk_update_cmd: bitkeeper update command
137 local ebk_update_cmd="update"
138
139 # addread "/etc/bitkeeper"
140 addwrite "${ebk_store_dir}"
141
142 if [[ ! -d "${ebk_store_dir}" ]] ; then
143 debug-print "${FUNCNAME}: initial checkout, creating bitkeeper directory ..."
144 mkdir -p "${ebk_store_dir}" || die "BK: couldn't mkdir ${ebk_store_dir}"
145 fi
146
147 pushd "${ebk_store_dir}" || die "BK: couldn't chdir to ${ebk_store_dir}"
148
149 local wc_path=${reposuf}
150
151 if [[ ! -d "${wc_path}" ]] ; then
152 local options="-r+"
153
154 # first checkout
155 einfo "bitkeeper checkout start -->"
156 einfo " repository: ${repo_uri}"
157
158 ${ebk_fetch_cmd} ${options} "${repo_uri}" "${wc_path}" \
159 || die "BK: couldn't fetch from ${repo_uri}"
160 else
161 if [[ ! -d "${wc_path}/BK" ]] ; then
162 popd
163 die "Looks like ${wc_path} is not a bitkeeper path"
164 fi
165
166 # update working copy
167 einfo "bitkeeper update start -->"
168 einfo " repository: ${repo_uri}"
169
170 ${ebk_update_cmd} "${repo_uri}" "${wc_path}" \
171 || die "BK: couldn't update from ${repo_uri} to ${wc_path}"
172 fi
173
174 einfo " working copy: ${wc_path}"
175 cd "${wc_path}"
176 rsync -rlpgo --exclude="BK/" . "${S}" || die "BK: couldn't export to ${S}"
177
178 echo
179 popd
180}
181 160
182mysql_disable_test() { 161mysql_disable_test() {
183 local testname="${1}" ; shift 162 local testname="${1}" ; shift
184 local reason="${@}" 163 local reason="${@}"
185 local mysql_disable_file="${S}/mysql-test/t/disabled.def" 164 local mysql_disable_file="${S}/mysql-test/t/disabled.def"
198 MY_LIBDIR=${MY_LIBDIR="/usr/$(get_libdir)/mysql"} 177 MY_LIBDIR=${MY_LIBDIR="/usr/$(get_libdir)/mysql"}
199 MY_LOCALSTATEDIR=${MY_LOCALSTATEDIR="/var/lib/mysql"} 178 MY_LOCALSTATEDIR=${MY_LOCALSTATEDIR="/var/lib/mysql"}
200 MY_LOGDIR=${MY_LOGDIR="/var/log/mysql"} 179 MY_LOGDIR=${MY_LOGDIR="/var/log/mysql"}
201 MY_INCLUDEDIR=${MY_INCLUDEDIR="/usr/include/mysql"} 180 MY_INCLUDEDIR=${MY_INCLUDEDIR="/usr/include/mysql"}
202 181
203 if [[ -z "${DATADIR}" ]] ; then 182 if [[ -z "${MY_DATADIR}" ]] ; then
204 DATADIR="" 183 MY_DATADIR=""
205 if [[ -f "${MY_SYSCONFDIR}/my.cnf" ]] ; then 184 if [[ -f "${MY_SYSCONFDIR}/my.cnf" ]] ; then
206 DATADIR=`"my_print_defaults" mysqld 2>/dev/null \ 185 MY_DATADIR=`"my_print_defaults" mysqld 2>/dev/null \
207 | sed -ne '/datadir/s|^--datadir=||p' \ 186 | sed -ne '/datadir/s|^--datadir=||p' \
208 | tail -n1` 187 | tail -n1`
209 if [[ -z "${DATADIR}" ]] ; then 188 if [[ -z "${MY_DATADIR}" ]] ; then
210 DATADIR=`grep ^datadir "${MY_SYSCONFDIR}/my.cnf" \ 189 MY_DATADIR=`grep ^datadir "${MY_SYSCONFDIR}/my.cnf" \
211 | sed -e 's/.*=\s*//'` 190 | sed -e 's/.*=\s*//' \
191 | tail -n1`
212 fi 192 fi
213 fi 193 fi
214 if [[ -z "${DATADIR}" ]] ; then 194 if [[ -z "${MY_DATADIR}" ]] ; then
215 DATADIR="${MY_LOCALSTATEDIR}" 195 MY_DATADIR="${MY_LOCALSTATEDIR}"
216 einfo "Using default DATADIR" 196 einfo "Using default MY_DATADIR"
217 fi 197 fi
218 elog "MySQL DATADIR is ${DATADIR}" 198 elog "MySQL MY_DATADIR is ${MY_DATADIR}"
219 199
220 if [[ -z "${PREVIOUS_DATADIR}" ]] ; then 200 if [[ -z "${PREVIOUS_DATADIR}" ]] ; then
221 if [[ -e "${DATADIR}" ]] ; then 201 if [[ -e "${MY_DATADIR}" ]] ; then
222 elog "Previous datadir found, it's YOUR job to change" 202 # If you get this and you're wondering about it, see bug #207636
223 elog "ownership and take care of it" 203 elog "MySQL datadir found in ${MY_DATADIR}"
204 elog "A new one will not be created."
224 PREVIOUS_DATADIR="yes" 205 PREVIOUS_DATADIR="yes"
225 else 206 else
226 PREVIOUS_DATADIR="no" 207 PREVIOUS_DATADIR="no"
227 fi 208 fi
228 export PREVIOUS_DATADIR 209 export PREVIOUS_DATADIR
229 fi 210 fi
211 else
212 if [[ ${EBUILD_PHASE} == "config" ]]; then
213 local new_MY_DATADIR
214 new_MY_DATADIR=`"my_print_defaults" mysqld 2>/dev/null \
215 | sed -ne '/datadir/s|^--datadir=||p' \
216 | tail -n1`
217
218 if [[ ( -n "${new_MY_DATADIR}" ) && ( "${new_MY_DATADIR}" != "${MY_DATADIR}" ) ]]; then
219 ewarn "MySQL MY_DATADIR has changed"
220 ewarn "from ${MY_DATADIR}"
221 ewarn "to ${new_MY_DATADIR}"
222 MY_DATADIR="${new_MY_DATADIR}"
223 fi
224 fi
230 fi 225 fi
231 226
232 MY_SOURCEDIR=${SERVER_URI##*/} 227 MY_SOURCEDIR=${SERVER_URI##*/}
233 MY_SOURCEDIR=${MY_SOURCEDIR%.tar*} 228 MY_SOURCEDIR=${MY_SOURCEDIR%.tar*}
234 229
235 export MY_SHAREDSTATEDIR MY_SYSCONFDIR 230 export MY_SHAREDSTATEDIR MY_SYSCONFDIR
236 export MY_LIBDIR MY_LOCALSTATEDIR MY_LOGDIR 231 export MY_LIBDIR MY_LOCALSTATEDIR MY_LOGDIR
237 export MY_INCLUDEDIR DATADIR MY_SOURCEDIR 232 export MY_INCLUDEDIR MY_DATADIR MY_SOURCEDIR
238} 233}
239 234
240configure_minimal() { 235configure_minimal() {
241 # These are things we exclude from a minimal build, please 236 # These are things we exclude from a minimal build, please
242 # note that the server actually does get built and installed, 237 # note that the server actually does get built and installed,
243 # but we then delete it before packaging. 238 # but we then delete it before packaging.
244 local minimal_exclude_list="server embedded-server extra-tools innodb bench berkeley-db row-based-replication" 239 local minimal_exclude_list="server embedded-server extra-tools innodb bench berkeley-db row-based-replication readline"
245 240
246 for i in ${minimal_exclude_list} ; do 241 for i in ${minimal_exclude_list} ; do
247 myconf="${myconf} --without-${i}" 242 myconf="${myconf} --without-${i}"
248 done 243 done
249 myconf="${myconf} --with-extra-charsets=none" 244 myconf="${myconf} --with-extra-charsets=none"
250 myconf="${myconf} --enable-local-infile" 245 myconf="${myconf} --enable-local-infile"
251 246
252 if use static ; then 247 if use static ; then
253 myconf="${myconf} --with-client-ldflags=-all-static" 248 myconf="${myconf} --with-client-ldflags=-all-static"
254 myconf="${myconf} --disable-shared" 249 myconf="${myconf} --disable-shared --with-pic"
255 else 250 else
256 myconf="${myconf} --enable-shared --enable-static" 251 myconf="${myconf} --enable-shared --enable-static"
257 fi 252 fi
258 253
259 if mysql_version_is_at_least "4.1" && ! use latin1 ; then 254 if mysql_version_is_at_least "4.1" && ! use latin1 ; then
275 myconf="${myconf} --without-libwrap" 270 myconf="${myconf} --without-libwrap"
276 271
277 if use static ; then 272 if use static ; then
278 myconf="${myconf} --with-mysqld-ldflags=-all-static" 273 myconf="${myconf} --with-mysqld-ldflags=-all-static"
279 myconf="${myconf} --with-client-ldflags=-all-static" 274 myconf="${myconf} --with-client-ldflags=-all-static"
280 myconf="${myconf} --disable-shared" 275 myconf="${myconf} --disable-shared --with-pic"
281 else 276 else
282 myconf="${myconf} --enable-shared --enable-static" 277 myconf="${myconf} --enable-shared --enable-static"
283 fi 278 fi
284 279
285 if use debug ; then 280 if use debug ; then
289 mysql_version_is_at_least "4.1.3" \ 284 mysql_version_is_at_least "4.1.3" \
290 && use cluster \ 285 && use cluster \
291 && myconf="${myconf} --without-ndb-debug" 286 && myconf="${myconf} --without-ndb-debug"
292 fi 287 fi
293 288
289 if [ -n "${MYSQL_DEFAULT_CHARSET}" -a -n "${MYSQL_DEFAULT_COLLATION}" ]; then
290 ewarn "You are using a custom charset of ${MYSQL_DEFAULT_CHARSET}"
291 ewarn "and a collation of ${MYSQL_DEFAULT_COLLATION}."
292 ewarn "You MUST file bugs without these variables set."
293 myconf="${myconf} --with-charset=${MYSQL_DEFAULT_CHARSET}"
294 myconf="${myconf} --with-collation=${MYSQL_DEFAULT_COLLATION}"
294 if mysql_version_is_at_least "4.1" && ! use latin1 ; then 295 elif mysql_version_is_at_least "4.1" && ! use latin1 ; then
295 myconf="${myconf} --with-charset=utf8" 296 myconf="${myconf} --with-charset=utf8"
296 myconf="${myconf} --with-collation=utf8_general_ci" 297 myconf="${myconf} --with-collation=utf8_general_ci"
297 else 298 else
298 myconf="${myconf} --with-charset=latin1" 299 myconf="${myconf} --with-charset=latin1"
299 myconf="${myconf} --with-collation=latin1_swedish_ci" 300 myconf="${myconf} --with-collation=latin1_swedish_ci"
300 fi 301 fi
301 302
302 if use embedded ; then 303 if use embedded ; then
303 myconf="${myconf} --with-embedded-privilege-control" 304 myconf="${myconf} --with-embedded-privilege-control"
304 myconf="${myconf} --with-embedded-server" 305 myconf="${myconf} --with-embedded-server"
327 myconf="${myconf} $(use_with ssl)" 328 myconf="${myconf} $(use_with ssl)"
328 else 329 else
329 myconf="${myconf} $(use_with ssl openssl)" 330 myconf="${myconf} $(use_with ssl openssl)"
330 fi 331 fi
331 332
333 if mysql_version_is_at_least "5.0.60" ; then
334 if use berkdb ; then
335 elog "Berkeley DB support was disabled due to build failures"
336 elog "on multiple arches, go to a version earlier than 5.0.60"
337 elog "if you want it again. Gentoo bug #224067."
338 fi
339 myconf="${myconf} --without-berkeley-db"
340 elif use berkdb ; then
332 # The following fix is due to a bug with bdb on SPARC's. See: 341 # The following fix is due to a bug with bdb on SPARC's. See:
333 # http://www.geocrawler.com/mail/msg.php3?msg_id=4754814&list=8 342 # http://www.geocrawler.com/mail/msg.php3?msg_id=4754814&list=8
334 # It comes down to non-64-bit safety problems. 343 # It comes down to non-64-bit safety problems.
335 if use alpha || use amd64 || use hppa || use mips || use sparc ; then 344 if use alpha || use amd64 || use hppa || use mips || use sparc ; then
336 elog "Berkeley DB support was disabled due to incompatible arch" 345 elog "Berkeley DB support was disabled due to compatibility issues on this arch"
346 myconf="${myconf} --without-berkeley-db"
347 else
348 myconf="${myconf} --with-berkeley-db=./bdb"
349 fi
350 else
337 myconf="${myconf} --without-berkeley-db" 351 myconf="${myconf} --without-berkeley-db"
338 else
339 if use berkdb ; then
340 myconf="${myconf} --with-berkeley-db=./bdb"
341 else
342 myconf="${myconf} --without-berkeley-db"
343 fi
344 fi 352 fi
345 353
346 if mysql_version_is_at_least "4.1.3" ; then 354 if mysql_version_is_at_least "4.1.3" ; then
347 myconf="${myconf} --with-geometry" 355 myconf="${myconf} --with-geometry"
348 myconf="${myconf} $(use_with cluster ndbcluster)" 356 myconf="${myconf} $(use_with cluster ndbcluster)"
363 # http://dev.mysql.com/doc/mysql/en/federated-limitations.html 371 # http://dev.mysql.com/doc/mysql/en/federated-limitations.html
364 if mysql_version_is_at_least "5.0.3" ; then 372 if mysql_version_is_at_least "5.0.3" ; then
365 elog "Before using the Federated storage engine, please be sure to read" 373 elog "Before using the Federated storage engine, please be sure to read"
366 elog "http://dev.mysql.com/doc/mysql/en/federated-limitations.html" 374 elog "http://dev.mysql.com/doc/mysql/en/federated-limitations.html"
367 myconf="${myconf} --with-federated-storage-engine" 375 myconf="${myconf} --with-federated-storage-engine"
376 fi
377 fi
378
379 if [ "${MYSQL_COMMUNITY_FEATURES}" == "1" ]; then
380 myconf="${myconf} `use_enable community community-features`"
381 if use community; then
382 myconf="${myconf} `use_enable profiling`"
383 else
384 myconf="${myconf} --disable-profiling"
368 fi 385 fi
369 fi 386 fi
370 387
371 mysql_version_is_at_least "5.0.18" \ 388 mysql_version_is_at_least "5.0.18" \
372 && use max-idx-128 \ 389 && use max-idx-128 \
395 412
396 elog "Before using the Federated storage engine, please be sure to read" 413 elog "Before using the Federated storage engine, please be sure to read"
397 elog "http://dev.mysql.com/doc/refman/5.1/en/federated-limitations.html" 414 elog "http://dev.mysql.com/doc/refman/5.1/en/federated-limitations.html"
398 fi 415 fi
399 416
400 if use innodb ; then 417 # Upstream specifically requests that InnoDB always be built.
401 plugins="${plugins},innobase" 418 plugins="${plugins},innobase"
402 fi
403 419
404 # like configuration=max-no-ndb 420 # like configuration=max-no-ndb
405 if use cluster ; then 421 if use cluster ; then
406 plugins="${plugins},ndbcluster" 422 plugins="${plugins},ndbcluster"
407 myconf="${myconf} --with-ndb-binlog" 423 myconf="${myconf} --with-ndb-binlog"
412 fi 428 fi
413 429
414 myconf="${myconf} --with-plugins=${plugins}" 430 myconf="${myconf} --with-plugins=${plugins}"
415} 431}
416 432
417pbxt_src_compile() { 433pbxt_src_configure() {
418 mysql_init_vars 434 mysql_init_vars
419 435
420 pushd "${WORKDIR}/pbxt-${PBXT_VERSION}" &>/dev/null 436 pushd "${WORKDIR}/pbxt-${PBXT_VERSION}" &>/dev/null
421 437
422 einfo "Reconfiguring dir '${PWD}'" 438 einfo "Reconfiguring dir '${PWD}'"
425 local myconf="" 441 local myconf=""
426 myconf="${myconf} --with-mysql=${S} --libdir=${D}/${MY_LIBDIR}" 442 myconf="${myconf} --with-mysql=${S} --libdir=${D}/${MY_LIBDIR}"
427 use debug && myconf="${myconf} --with-debug=full" 443 use debug && myconf="${myconf} --with-debug=full"
428 # TODO: is it safe/needed to use econf here ? 444 # TODO: is it safe/needed to use econf here ?
429 ./configure ${myconf} || die "Problem configuring PBXT storage engine" 445 ./configure ${myconf} || die "Problem configuring PBXT storage engine"
446}
447
448pbxt_src_compile() {
449 # Be backwards compatible for now
450 if [[ $EAPI != 2 ]]; then
451 pbxt_src_configure
452 fi
430 # TODO: is it safe/needed to use emake here ? 453 # TODO: is it safe/needed to use emake here ?
431 make || die "Problem making PBXT storage engine (${myconf})" 454 make || die "Problem making PBXT storage engine (${myconf})"
432 455
433 popd 456 popd
434 # TODO: modify test suite for PBXT 457 # TODO: modify test suite for PBXT
441} 464}
442 465
443# 466#
444# EBUILD FUNCTIONS 467# EBUILD FUNCTIONS
445# 468#
446
447mysql_pkg_setup() { 469mysql_pkg_setup() {
448 enewgroup mysql 60 || die "problem adding 'mysql' group" 470 if hasq test ${FEATURES} ; then
449 enewuser mysql 60 -1 /dev/null mysql || die "problem adding 'mysql' user" 471 if ! use minimal ; then
472 if [[ $UID -eq 0 ]]; then
473 eerror "Testing with FEATURES=-userpriv is no longer supported by upstream. Tests MUST be run as non-root."
474 fi
475 fi
476 fi
450 477
451 # Check for USE flag problems in pkg_setup 478 # Check for USE flag problems in pkg_setup
452 if use static && use ssl ; then 479 if use static && use ssl ; then
453 eerror "MySQL does not support being built statically with SSL support enabled!" 480 eerror "MySQL does not support being built statically with SSL support enabled!"
454 die "MySQL does not support being built statically with SSL support enabled!" 481 die "MySQL does not support being built statically with SSL support enabled!"
467 && use minimal ; then 494 && use minimal ; then
468 eerror "USE flags 'cluster' and 'extraengine' conflict with 'minimal' USE flag!" 495 eerror "USE flags 'cluster' and 'extraengine' conflict with 'minimal' USE flag!"
469 die "USE flags 'cluster' and 'extraengine' conflict with 'minimal' USE flag!" 496 die "USE flags 'cluster' and 'extraengine' conflict with 'minimal' USE flag!"
470 fi 497 fi
471 498
499 # This should come after all of the die statements
500 enewgroup mysql 60 || die "problem adding 'mysql' group"
501 enewuser mysql 60 -1 /dev/null mysql || die "problem adding 'mysql' user"
502
472 mysql_check_version_range "4.0 to 5.0.99.99" \ 503 mysql_check_version_range "4.0 to 5.0.99.99" \
473 && use berkdb \ 504 && use berkdb \
474 && elog "Berkeley DB support is deprecated and will be removed in future versions!" 505 && elog "Berkeley DB support is deprecated and will be removed in future versions!"
475} 506}
476 507
477mysql_src_unpack() { 508mysql_src_unpack() {
478 # Initialize the proper variables first 509 # Initialize the proper variables first
479 mysql_init_vars 510 mysql_init_vars
480 511
481 unpack ${A} 512 unpack ${A}
482 if [[ ${IS_BITKEEPER} -eq 90 ]] ; then 513 # Grab the patches
483 if mysql_check_version_range "5.1 to 5.1.99" ; then 514 [[ "${MY_EXTRAS_VER}" == "live" ]] && S="${WORKDIR}/mysql-extras" git_src_unpack
484 bitkeeper_fetch "mysql-5.1-ndb" 515
485 elif mysql_check_version_range "5.2 to 5.2.99" ; then
486 bitkeeper_fetch "mysql-5.2-falcon"
487 else
488 bitkeeper_fetch
489 fi
490 cd "${S}"
491 einfo "Running upstream autorun over BK sources ..."
492 BUILD/autorun.sh
493 else
494 mv -f "${WORKDIR}/${MY_SOURCEDIR}" "${S}" 516 mv -f "${WORKDIR}/${MY_SOURCEDIR}" "${S}"
517
518 # Be backwards compatible for now
519 if [[ $EAPI != 2 ]]; then
520 mysql_src_prepare
521 fi
522}
523
524mysql_src_prepare() {
495 cd "${S}" 525 cd "${S}"
496 fi
497 526
498 # Apply the patches for this MySQL version 527 # Apply the patches for this MySQL version
499 EPATCH_SUFFIX="patch" 528 EPATCH_SUFFIX="patch"
500 mkdir -p "${EPATCH_SOURCE}" || die "Unable to create epatch directory" 529 mkdir -p "${EPATCH_SOURCE}" || die "Unable to create epatch directory"
530 # Clean out old items
531 rm -f "${EPATCH_SOURCE}"/*
532 # Now link in right patches
501 mysql_mv_patches 533 mysql_mv_patches
534 # And apply
502 epatch 535 epatch
503 536
504 # Additional checks, remove bundled zlib 537 # Additional checks, remove bundled zlib
505 rm -f "${S}/zlib/"*.[ch] 538 rm -f "${S}/zlib/"*.[ch]
506 sed -i -e "s/zlib\/Makefile dnl/dnl zlib\/Makefile/" "${S}/configure.in" 539 sed -i -e "s/zlib\/Makefile dnl/dnl zlib\/Makefile/" "${S}/configure.in"
522 555
523 local rebuilddirlist d 556 local rebuilddirlist d
524 557
525 if mysql_version_is_at_least "5.1.12" ; then 558 if mysql_version_is_at_least "5.1.12" ; then
526 rebuilddirlist="." 559 rebuilddirlist="."
527 # TODO: check this with a cmake expert 560 # TODO: check this with a cmake expert
528 use innodb \
529 && cmake \ 561 cmake \
530 -DCMAKE_C_COMPILER=$(type -P $(tc-getCC)) \ 562 -DCMAKE_C_COMPILER=$(type -P $(tc-getCC)) \
531 -DCMAKE_CXX_COMPILER=$(type -P $(tc-getCC)) \ 563 -DCMAKE_CXX_COMPILER=$(type -P $(tc-getCXX)) \
532 "storage/innobase" 564 "storage/innobase"
533 else 565 else
534 rebuilddirlist=". innobase" 566 rebuilddirlist=". innobase"
535 fi 567 fi
536 568
544 if mysql_check_version_range "4.1 to 5.0.99.99" \ 576 if mysql_check_version_range "4.1 to 5.0.99.99" \
545 && use berkdb ; then 577 && use berkdb ; then
546 [[ -w "bdb/dist/ltmain.sh" ]] && cp -f "ltmain.sh" "bdb/dist/ltmain.sh" 578 [[ -w "bdb/dist/ltmain.sh" ]] && cp -f "ltmain.sh" "bdb/dist/ltmain.sh"
547 cp -f "/usr/share/aclocal/libtool.m4" "bdb/dist/aclocal/libtool.ac" \ 579 cp -f "/usr/share/aclocal/libtool.m4" "bdb/dist/aclocal/libtool.ac" \
548 || die "Could not copy libtool.m4 to bdb/dist/" 580 || die "Could not copy libtool.m4 to bdb/dist/"
581 #These files exist only with libtool-2*, and need to be included.
582 if [ -f '/usr/share/aclocal/ltsugar.m4' ]; then
583 cat "/usr/share/aclocal/ltsugar.m4" >> "bdb/dist/aclocal/libtool.ac"
584 cat "/usr/share/aclocal/ltversion.m4" >> "bdb/dist/aclocal/libtool.ac"
585 cat "/usr/share/aclocal/lt~obsolete.m4" >> "bdb/dist/aclocal/libtool.ac"
586 cat "/usr/share/aclocal/ltoptions.m4" >> "bdb/dist/aclocal/libtool.ac"
587 fi
549 pushd "bdb/dist" &>/dev/null 588 pushd "bdb/dist" &>/dev/null
550 sh s_all \ 589 sh s_all \
551 || die "Failed bdb reconfigure" 590 || die "Failed bdb reconfigure"
552 popd &>/dev/null 591 popd &>/dev/null
553 fi 592 fi
554} 593}
555 594
556mysql_src_compile() { 595mysql_src_configure() {
557 # Make sure the vars are correctly initialized 596 # Make sure the vars are correctly initialized
558 mysql_init_vars 597 mysql_init_vars
559 598
560 # $myconf is modified by the configure_* functions 599 # $myconf is modified by the configure_* functions
561 local myconf="" 600 local myconf=""
575 filter-flags "-O" "-O[01]" 614 filter-flags "-O" "-O[01]"
576 615
577 # glib-2.3.2_pre fix, bug #16496 616 # glib-2.3.2_pre fix, bug #16496
578 append-flags "-DHAVE_ERRNO_AS_DEFINE=1" 617 append-flags "-DHAVE_ERRNO_AS_DEFINE=1"
579 618
619 # As discovered by bug #246652, doing a double-level of SSP causes NDB to
620 # fail badly during cluster startup.
621 if [[ $(gcc-major-version) -lt 4 ]]; then
622 filter-flags "-fstack-protector-all"
623 fi
624
580 CXXFLAGS="${CXXFLAGS} -fno-exceptions -fno-strict-aliasing" 625 CXXFLAGS="${CXXFLAGS} -fno-exceptions -fno-strict-aliasing"
581 CXXFLAGS="${CXXFLAGS} -felide-constructors -fno-rtti" 626 CXXFLAGS="${CXXFLAGS} -felide-constructors -fno-rtti"
582 mysql_version_is_at_least "5.0" \ 627 mysql_version_is_at_least "5.0" \
583 && CXXFLAGS="${CXXFLAGS} -fno-implicit-templates" 628 && CXXFLAGS="${CXXFLAGS} -fno-implicit-templates"
584 export CXXFLAGS 629 export CXXFLAGS
630
631 # bug #283926, with GCC4.4, this is required to get correct behavior.
632 append-flags -fno-strict-aliasing
585 633
586 econf \ 634 econf \
587 --libexecdir="/usr/sbin" \ 635 --libexecdir="/usr/sbin" \
588 --sysconfdir="${MY_SYSCONFDIR}" \ 636 --sysconfdir="${MY_SYSCONFDIR}" \
589 --localstatedir="${MY_LOCALSTATEDIR}" \ 637 --localstatedir="${MY_LOCALSTATEDIR}" \
600 # TODO: Move this before autoreconf !!! 648 # TODO: Move this before autoreconf !!!
601 find . -type f -name Makefile -print0 \ 649 find . -type f -name Makefile -print0 \
602 | xargs -0 -n100 sed -i \ 650 | xargs -0 -n100 sed -i \
603 -e 's|^pkglibdir *= *$(libdir)/mysql|pkglibdir = $(libdir)|;s|^pkgincludedir *= *$(includedir)/mysql|pkgincludedir = $(includedir)|' 651 -e 's|^pkglibdir *= *$(libdir)/mysql|pkglibdir = $(libdir)|;s|^pkgincludedir *= *$(includedir)/mysql|pkgincludedir = $(includedir)|'
604 652
653 if [[ $EAPI == 2 ]]; then
654 mysql_version_is_at_least "5.1.12" && use pbxt && pbxt_src_configure
655 fi
656}
657
658mysql_src_compile() {
659 # Be backwards compatible for now
660 if [[ $EAPI != 2 ]]; then
661 mysql_src_configure
662 fi
663
605 emake || die "emake failed" 664 emake || die "emake failed"
606 665
607 mysql_version_is_at_least "5.1.12" && use pbxt && pbxt_src_compile 666 mysql_version_is_at_least "5.1.12" && use pbxt && pbxt_src_compile
608} 667}
609 668
613 672
614 emake install DESTDIR="${D}" benchdir_root="${MY_SHAREDSTATEDIR}" || die "emake install failed" 673 emake install DESTDIR="${D}" benchdir_root="${MY_SHAREDSTATEDIR}" || die "emake install failed"
615 674
616 mysql_version_is_at_least "5.1.12" && use pbxt && pbxt_src_install 675 mysql_version_is_at_least "5.1.12" && use pbxt && pbxt_src_install
617 676
618 insinto "${MY_INCLUDEDIR}"
619 doins "${MY_INCLUDEDIR}"/my_{config,dir}.h
620
621 # Convenience links 677 # Convenience links
678 einfo "Making Convenience links for mysqlcheck multi-call binary"
622 dosym "/usr/bin/mysqlcheck" "/usr/bin/mysqlanalyze" 679 dosym "/usr/bin/mysqlcheck" "/usr/bin/mysqlanalyze"
623 dosym "/usr/bin/mysqlcheck" "/usr/bin/mysqlrepair" 680 dosym "/usr/bin/mysqlcheck" "/usr/bin/mysqlrepair"
624 dosym "/usr/bin/mysqlcheck" "/usr/bin/mysqloptimize" 681 dosym "/usr/bin/mysqlcheck" "/usr/bin/mysqloptimize"
625 682
626 # Various junk (my-*.cnf moved elsewhere) 683 # Various junk (my-*.cnf moved elsewhere)
684 einfo "Removing duplicate /usr/share/mysql files"
627 rm -Rf "${D}/usr/share/info" 685 rm -Rf "${D}/usr/share/info"
628 for removeme in "mysql-log-rotate" mysql.server* \ 686 for removeme in "mysql-log-rotate" mysql.server* \
629 binary-configure* my-*.cnf mi_test_all* 687 binary-configure* my-*.cnf mi_test_all*
630 do 688 do
631 rm -f "${D}"/usr/share/mysql/${removeme} 689 rm -f "${D}"/usr/share/mysql/${removeme}
632 done 690 done
633 691
634 # Clean up stuff for a minimal build 692 # Clean up stuff for a minimal build
635 if use minimal ; then 693 if use minimal ; then
694 einfo "Remove all extra content for minimal build"
636 rm -Rf "${D}${MY_SHAREDSTATEDIR}"/{mysql-test,sql-bench} 695 rm -Rf "${D}${MY_SHAREDSTATEDIR}"/{mysql-test,sql-bench}
637 rm -f "${D}"/usr/bin/{mysql{_install_db,manager*,_secure_installation,_fix_privilege_tables,hotcopy,_convert_table_format,d_multi,_fix_extensions,_zap,_explain_log,_tableinfo,d_safe,_install,_waitpid,binlog,test},myisam*,isam*,pack_isam} 696 rm -f "${D}"/usr/bin/{mysql{_install_db,manager*,_secure_installation,_fix_privilege_tables,hotcopy,_convert_table_format,d_multi,_fix_extensions,_zap,_explain_log,_tableinfo,d_safe,_install,_waitpid,binlog,test},myisam*,isam*,pack_isam}
638 rm -f "${D}/usr/sbin/mysqld" 697 rm -f "${D}/usr/sbin/mysqld"
639 rm -f "${D}${MY_LIBDIR}"/lib{heap,merge,nisam,my{sys,strings,sqld,isammrg,isam},vio,dbug}.a 698 rm -f "${D}${MY_LIBDIR}"/lib{heap,merge,nisam,my{sys,strings,sqld,isammrg,isam},vio,dbug}.a
640 fi 699 fi
643 if mysql_version_is_at_least "4.1" ; then 702 if mysql_version_is_at_least "4.1" ; then
644 mysql_mycnf_version="4.1" 703 mysql_mycnf_version="4.1"
645 else 704 else
646 mysql_mycnf_version="4.0" 705 mysql_mycnf_version="4.0"
647 fi 706 fi
707 einfo "Building default my.cnf"
648 insinto "${MY_SYSCONFDIR}" 708 insinto "${MY_SYSCONFDIR}"
649 doins scripts/mysqlaccess.conf 709 doins scripts/mysqlaccess.conf
650 sed -e "s!@DATADIR@!${DATADIR}!g" \ 710 sed -e "s!@DATADIR@!${MY_DATADIR}!g" \
651 "${FILESDIR}/my.cnf-${mysql_mycnf_version}" \ 711 "${FILESDIR}/my.cnf-${mysql_mycnf_version}" \
652 > "${TMPDIR}/my.cnf.ok" 712 > "${TMPDIR}/my.cnf.ok"
653 if mysql_version_is_at_least "4.1" && use latin1 ; then 713 if mysql_version_is_at_least "4.1" && use latin1 ; then
654 sed -e "s|utf8|latin1|g" -i "${TMPDIR}/my.cnf.ok" 714 sed -e "s|utf8|latin1|g" -i "${TMPDIR}/my.cnf.ok"
655 fi 715 fi
656 newins "${TMPDIR}/my.cnf.ok" my.cnf 716 newins "${TMPDIR}/my.cnf.ok" my.cnf
657 717
658 # Minimal builds don't have the MySQL server 718 # Minimal builds don't have the MySQL server
659 if ! use minimal ; then 719 if ! use minimal ; then
720 einfo "Creating initial directories"
660 # Empty directories ... 721 # Empty directories ...
661 diropts "-m0750" 722 diropts "-m0750"
662 if [[ "${PREVIOUS_DATADIR}" != "yes" ]] ; then 723 if [[ "${PREVIOUS_DATADIR}" != "yes" ]] ; then
663 dodir "${DATADIR}" 724 dodir "${MY_DATADIR}"
664 keepdir "${DATADIR}" 725 keepdir "${MY_DATADIR}"
665 chown -R mysql:mysql "${D}/${DATADIR}" 726 chown -R mysql:mysql "${D}/${MY_DATADIR}"
666 fi 727 fi
667 728
668 diropts "-m0755" 729 diropts "-m0755"
669 for folder in "${MY_LOGDIR}" "/var/run/mysqld" ; do 730 for folder in "${MY_LOGDIR}" "/var/run/mysqld" ; do
670 dodir "${folder}" 731 dodir "${folder}"
672 chown -R mysql:mysql "${D}/${folder}" 733 chown -R mysql:mysql "${D}/${folder}"
673 done 734 done
674 fi 735 fi
675 736
676 # Docs 737 # Docs
738 einfo "Installing docs"
677 dodoc README COPYING ChangeLog EXCEPTIONS-CLIENT INSTALL-SOURCE 739 dodoc README COPYING ChangeLog EXCEPTIONS-CLIENT INSTALL-SOURCE
740 doinfo "${S}"/Docs/mysql.info
678 741
679 # Minimal builds don't have the MySQL server 742 # Minimal builds don't have the MySQL server
680 if ! use minimal ; then 743 if ! use minimal ; then
744 einfo "Including support files and sample configurations"
681 docinto "support-files" 745 docinto "support-files"
682 for script in \ 746 for script in \
683 support-files/my-*.cnf \ 747 "${S}"/support-files/my-*.cnf \
684 support-files/magic \ 748 "${S}"/support-files/magic \
685 support-files/ndb-config-2-node.ini 749 "${S}"/support-files/ndb-config-2-node.ini
686 do 750 do
687 dodoc "${script}" 751 dodoc "${script}"
688 done 752 done
689 753
690 docinto "scripts" 754 docinto "scripts"
691 for script in scripts/mysql* ; do 755 for script in "${S}"/scripts/mysql* ; do
692 [[ "${script%.sh}" == "${script}" ]] && dodoc "${script}" 756 [[ "${script%.sh}" == "${script}" ]] && dodoc "${script}"
693 done 757 done
758
694 fi 759 fi
695 760
696 mysql_lib_symlinks "${D}" 761 mysql_lib_symlinks "${D}"
697} 762}
698 763
755 && use berkdb \ 820 && use berkdb \
756 && elog "Berkeley DB support is deprecated and will be removed in future versions!" 821 && elog "Berkeley DB support is deprecated and will be removed in future versions!"
757} 822}
758 823
759mysql_pkg_config() { 824mysql_pkg_config() {
825 local old_MY_DATADIR="${MY_DATADIR}"
826
760 # Make sure the vars are correctly initialized 827 # Make sure the vars are correctly initialized
761 mysql_init_vars 828 mysql_init_vars
762 829
763 [[ -z "${DATADIR}" ]] && die "Sorry, unable to find DATADIR" 830 [[ -z "${MY_DATADIR}" ]] && die "Sorry, unable to find MY_DATADIR"
764 831
765 if built_with_use ${CATEGORY}/${PN} minimal ; then 832 if built_with_use ${CATEGORY}/${PN} minimal ; then
766 die "Minimal builds do NOT include the MySQL server" 833 die "Minimal builds do NOT include the MySQL server"
834 fi
835
836 if [[ ( -n "${MY_DATADIR}" ) && ( "${MY_DATADIR}" != "${old_MY_DATADIR}" ) ]]; then
837 local MY_DATADIR_s="$(strip_duplicate_slashes ${ROOT}/${MY_DATADIR})"
838 local old_MY_DATADIR_s="$(strip_duplicate_slashes ${ROOT}/${old_MY_DATADIR})"
839
840 if [[ -d "${old_MY_DATADIR_s}" ]]; then
841 if [[ -d "${MY_DATADIR_s}" ]]; then
842 ewarn "Both ${old_MY_DATADIR_s} and ${MY_DATADIR_s} exist"
843 ewarn "Attempting to use ${MY_DATADIR_s} and preserving ${old_MY_DATADIR_s}"
844 else
845 elog "Moving MY_DATADIR from ${old_MY_DATADIR_s} to ${MY_DATADIR_s}"
846 mv --strip-trailing-slashes -T "${old_MY_DATADIR_s}" "${MY_DATADIR_s}" \
847 || die "Moving MY_DATADIR failed"
848 fi
849 else
850 ewarn "Previous MY_DATADIR (${old_MY_DATADIR_s}) does not exist"
851 if [[ -d "${MY_DATADIR_s}" ]]; then
852 ewarn "Attempting to use ${MY_DATADIR_s}"
853 else
854 eerror "New MY_DATADIR (${MY_DATADIR_s}) does not exist"
855 die "Configuration Failed! Please reinstall ${CATEGORY}/${PN}"
856 fi
857 fi
767 fi 858 fi
768 859
769 local pwd1="a" 860 local pwd1="a"
770 local pwd2="b" 861 local pwd2="b"
771 local maxtry=5 862 local maxtry=5
772 863
773 if [[ -d "${ROOT}/${DATADIR}/mysql" ]] ; then 864 if [[ -d "${ROOT}/${MY_DATADIR}/mysql" ]] ; then
774 ewarn "You have already a MySQL database in place." 865 ewarn "You have already a MySQL database in place."
775 ewarn "(${ROOT}/${DATADIR}/*)" 866 ewarn "(${ROOT}/${MY_DATADIR}/*)"
776 ewarn "Please rename or delete it if you wish to replace it." 867 ewarn "Please rename or delete it if you wish to replace it."
777 die "MySQL database already exists!" 868 die "MySQL database already exists!"
778 fi 869 fi
870
871 # Bug #213475 - MySQL _will_ object strenously if your machine is named
872 # localhost. Also causes weird failures.
873 [[ "${HOSTNAME}" == "localhost" ]] && die "Your machine must NOT be named localhost"
779 874
780 einfo "Creating the mysql database and setting proper" 875 einfo "Creating the mysql database and setting proper"
781 einfo "permissions on it ..." 876 einfo "permissions on it ..."
782 877
783 einfo "Insert a password for the mysql 'root' user" 878 einfo "Insert a password for the mysql 'root' user"
799 && cp "${help_tables}" "${TMPDIR}/fill_help_tables.sql" \ 894 && cp "${help_tables}" "${TMPDIR}/fill_help_tables.sql" \
800 || touch "${TMPDIR}/fill_help_tables.sql" 895 || touch "${TMPDIR}/fill_help_tables.sql"
801 help_tables="${TMPDIR}/fill_help_tables.sql" 896 help_tables="${TMPDIR}/fill_help_tables.sql"
802 897
803 pushd "${TMPDIR}" &>/dev/null 898 pushd "${TMPDIR}" &>/dev/null
804 "${ROOT}/usr/bin/mysql_install_db" | grep -B5 -A999 -i "ERROR" 899 "${ROOT}/usr/bin/mysql_install_db" >"${TMPDIR}"/mysql_install_db.log 2>&1
900 if [ $? -ne 0 ]; then
901 grep -B5 -A999 -i "ERROR" "${TMPDIR}"/mysql_install_db.log 1>&2
902 die "Failed to run mysql_install_db. Please review /var/log/mysql/mysqld.err AND ${TMPDIR}/mysql_install_db.log"
903 fi
805 popd &>/dev/null 904 popd &>/dev/null
806 [[ -f "${ROOT}/${DATADIR}/mysql/user.frm" ]] \ 905 [[ -f "${ROOT}/${MY_DATADIR}/mysql/user.frm" ]] \
807 || die "MySQL databases not installed" 906 || die "MySQL databases not installed"
808 chown -R mysql:mysql "${ROOT}/${DATADIR}" 2> /dev/null 907 chown -R mysql:mysql "${ROOT}/${MY_DATADIR}" 2>/dev/null
809 chmod 0750 "${ROOT}/${DATADIR}" 2> /dev/null 908 chmod 0750 "${ROOT}/${MY_DATADIR}" 2>/dev/null
810 909
811 if mysql_version_is_at_least "4.1.3" ; then 910 if mysql_version_is_at_least "4.1.3" ; then
812 options="--skip-ndbcluster" 911 options="--skip-ndbcluster"
813 912
814 # Filling timezones, see 913 # Filling timezones, see
825 local mysqld="${ROOT}/usr/sbin/mysqld \ 924 local mysqld="${ROOT}/usr/sbin/mysqld \
826 ${options} \ 925 ${options} \
827 --user=mysql \ 926 --user=mysql \
828 --skip-grant-tables \ 927 --skip-grant-tables \
829 --basedir=${ROOT}/usr \ 928 --basedir=${ROOT}/usr \
830 --datadir=${ROOT}/${DATADIR} \ 929 --datadir=${ROOT}/${MY_DATADIR} \
831 --skip-innodb \ 930 --skip-innodb \
832 --skip-bdb \ 931 --skip-bdb \
833 --skip-networking \ 932 --skip-networking \
834 --max_allowed_packet=8M \ 933 --max_allowed_packet=8M \
835 --net_buffer_length=16K \ 934 --net_buffer_length=16K \

Legend:
Removed from v.1.73  
changed lines
  Added in v.1.117

  ViewVC Help
Powered by ViewVC 1.1.20